import { SET_PAYMENT_TERMS, SET_LOADING_PAYMENT_TERMS, SET_PAYMENT_TYPE } from '@/constants/mutationTypes'
import { INIT_PAYMENT_TERMS, CHANGE_PAYMENT_TYPE } from '@/constants/actionTypes'

const initialState = {
    paymentTerms: [],
    loadingPaymentTerms: false,
    paymentType: 'cash'
}

const state = {
    paymentTerms: initialState.paymentTerms,
    loadingPaymentTerms: !initialState.loadingPaymentTerms,
    paymentType: initialState.paymentType
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    paymentTerms(state) {
        return state.paymentTerms
    },
    /**
     * 
     * @param {*} state 
     */
    loadingPaymentTerms(state) {
        return state.loadingPaymentTerms
    },
    /**
     * 
     * @param {*} state 
     */
    paymentType(state) {
        return state.paymentType
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_PAYMENT_TERMS] (state, payload) {
        state.paymentTerms = payload
    },
    /**
     * 
     * @param {*} state 
     */
    [SET_LOADING_PAYMENT_TERMS] (state, payload) {
        state.loadingPaymentTerms = !!payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_PAYMENT_TYPE] (state, payload) {
        state.paymentType = payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    [INIT_PAYMENT_TERMS] ({ commit }, payload) {
        commit(SET_PAYMENT_TERMS, payload)
        commit(SET_LOADING_PAYMENT_TERMS)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    [CHANGE_PAYMENT_TYPE] ({ commit }, payload) {
        commit(SET_PAYMENT_TYPE, payload)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}